Anfang         call    Empfangen       ;Adresse empfangen
               mov     r0,a            ;Adresse in r0 laden
               rlc     a               ;hchstes Bit testen
               jc      Lesen
               call    Empfangen       ;Datenbyte empfangen
               anl     p2,#DFh         ;P25 = 0
               movx    @r0,a           ;Ausgabe auf den Bus
               jmp     Anfang
Lesen          mov     a,r0
               anl     a,#7Fh          ;hchstes Bit zurcksetzen
               mov     r0,a
               orl     p2,#20h
               movx    a,@r0           ;vom Bus lesen
               call    Senden          ;Datenbyte senden
               jmp     Anfang
Senden         mov     r5,#8           ;RS232-Ausgabe
               anl     p2,#7Fh         ;P27 = 0. Startbit
               mov     r6,#108
Sch1           djnz    r6,Sch1         ;Warteschleife Startbit
Sp1            clr     c               ;Zeitausgleich 1 Zyklus
               rrc     a               ;Datenbit in C schieben
               jc      Sp2             ;wenn C = 0,
               anl     p2,#7Fh         ;dann P27 = 0
               jmp     Sp3
Sp2            orl     p2,#80h         ;sonst P27 = 1
               orl     p2,#80h         ;Zeitausgleich 2 Zyklen
Sp3            mov     r6,#106
Sch2           djnz    r6,Sch2         ;Warteschleife Datenbit
               djnz    r5,Sp1          ;8 mal wiederholen
               mov     a,#0            ;Zeitausgleich 4 Zyklen
               mov     a,#0
               orl     p2,#80h         ;P27 = 1, Stopbit
               mov     r6,#108
Sch3           djnz    r6,Sch3         ;Warteschleife Stopbit
               ret
Empfangen      in      a,P2            ;RS232-Empfnger
               anl     a,#40h          ;P26 testen
               jnz     Empfangen       ;Schleife bis P26 = 0
               mov     r6,#150
Sch4           djnz    r6,Sch4         ;Warteschleife Startbit
               mov     r5,#8
Sp4            in      a,p2
               clr     c               ;Zeitausgleich 1 Zyklus
               rlc     a               ;Bit von P26 in C schieben
               rlc     a
               xch     a,r7            ;Datenbyte in a laden
               rrc     a               ;C in a schieben
               xch     a,r7            ;Datenbyte zurckschreiben
               mov     r6,#106
Sch5           djnz    r6,Sch5         ;Warteschleife Datenbit
               djnz    r5,Sp4          ;8 mal wiederholen
               mov     a,r7            ;Datenbyte in a laden
               ret

