program Speichersteuerung;
uses Crt, RS232;
var      Frequenz    : Real;
         Ch          : Char;

procedure InitSpeicher;
begin
  BusOut (67, 130);              { 8255, A,C out, B in  }
  BusOut (71, 54);               { 8253, Timer 1, Mode 3}
  BusOut (71, 116);              { 8253, Timer 2, Mode 2}
  BusOut (68, 4);                { Vorteiler, 4 MHz/4   }
  BusOut (68, 0);
end;

Procedure Abtastrate (Frequenz : Real);
var   teiler     : Integer;
      High, Low  : Byte;
begin
  Teiler := trunc (1000/Frequenz);
  High := Hi (Teiler);
  Low := LO (Teiler);
  BusOut (69, Low);
  BusOut (69, High);
end;


begin
  InitSpeicher;
  Write ('Abtastrate in kHz ');
  Readln (Frequenz);
  Abtastrate (Frequenz);
  Writeln ('l Einlesen    a Ausgeben  e  Ende');
  Repeat
    Ch := Readkey;
    if Ch = 'l' then BusOut (66, 64);
    if Ch = 'a' then BusOut (66, 32);
  until ch = 'e';
end.
