PROGRAM Ausgabe;

uses CRT;
var
  Wert      :    Byte;
  Ch        :    Char;

procedure Oeffnen;
   var  Wert : Byte;
   begin
     Port [$3FB]:=128;          { Baudeingabe aktivieren    }
     Port [$3F8]:= 96;          { Baudrate - LSB, 1200 Baud }
     Port [$3F9]:=  0;          { Baudrate - MSB            }
     Port [$3FB]:=  3;          { 8 Bits, No Parity, 1 Stop }
     Port [$3FC]:=  3;          { DTR = 1, RTS = 1          }
     Wert := Port [$3F8]        { Empfangsregister leeren   }
   end;

procedure Schliessen;
   begin
     Port [$3FC]:=  0;          { DTR = 0, CTS = 0          }
   end;

procedure Senden  ( Wert : Byte );
   begin
     repeat
     until Port [$3FD] and 32 = 32;      { Abfrage, ob Sendepuffer leer }
     Port [$3F8]:= (Wert);               { Byte an Sendepuffer ausgeben }
   end;

procedure Empfangen ( var Wert : Byte );
   begin
     repeat until (Keypressed or
     ((Port [$3FD] and 1) = 1));        { Abfrage, ob Zeichen empfangen }
     Wert := Port [$3F8];               { Byte vom Empfangspuffer lesen }
   end;

begin
   Oeffnen;
   Ch := ReadKey;
   Wert := Integer (Ch);
   Senden (Wert);
   Schliessen
end.
