UNIT PLL;

Interface
uses Crt, RS232;

var Frequenz    : Real;
    Teiler, N   : Integer;
procedure PLL_Init;
procedure Einstellen (Frequenz: Real);

Implementation

procedure PLL_Init;
  begin
    BusOut (51,54);            { alle drei Timer Betriebsart 3 }
    BusOut (51,118);
    BusOut (51,182);
    BusOut (48,32);            { Teiler 1, 40000   (100 Hz)}
    BusOut (48,156);
    BusOut (49,200);           { Teiler 2, 200 }
    BusOut (49,0);
    BusOut (50,100);           { Teiler 3, 100 }
    BusOut (50,0);
  end;

procedure Einstellen (Frequenz: Real);
  var High, Low  : Byte;
    Teiler : Integer;
  begin
    Teiler := trunc (10 * Frequenz);
    High :=  Hi (Teiler);
    Low :=  Lo (Teiler);
    BusOut (49, Low);
    BusOut (49, High);
  end;

begin
end.

